#include <avr/io.h>
#define F_CPU 4000000
#include <util\delay.h>
#include <avr/wdt.h>

void USART_Vysilani( unsigned char data )
{
/* cekani na prazdny vysilaci buffer */
while ( !( UCSRA & (1<<UDRE)) )
;
/* vlozeni dat do bufferu, odeslani dat */
UDR=data;
}

void USART_Init(unsigned char baud)
{
// nastaveni baud rate
UBRRH = (unsigned char)(baud>>8);
UBRRL = (unsigned char)baud;

// nastaveni registru UCSRB
UCSRB =(1<<RXEN)| (1<<TXEN); // aktivovani vstupu a vystupu dat
}


unsigned char USART_Prijem(void)
{
/* cekani na prijata data */
long i=0;
while ( !(UCSRA & (1<<RXC)) )
{
wdt_reset();
i++;
if (i>(F_CPU/10)) break;
}
/* prijata data z bufferu */
return UDR;
}


void SPI_Init(void)
{
/* nastaveni MOSI a SCK jako vystup, ostatni jako vstup */
DDRB = (1<<DDB3)|(1<<DDB5)|(1<<DDB2);
/* povoleni SPI, master, hodiny fcl/128 */
SPCR = (1<<SPE)|(1<<MSTR)|(1<<SPR1)|(1<<SPR0);
}

unsigned char SPI_Prenos(unsigned char data)
{
    char temp;
	SPDR=data;
    while (!(SPSR & (1<<SPIF)));
    temp=SPDR;
	return temp;
}

void CSdown(void)
{
	//DDRB|=(1<<DDB2);
	PORTB&=(0<<PB2);
}

void CSup(void)
{
	//DDRB|=(1<<DDB2);
	PORTB|=(1<<PB2);
}








