#include <avr/io.h>
#include "mega.h"
#define F_CPU 4000000
#define BAUD 12
#include <util\delay.h>
#include <avr/wdt.h>
typedef unsigned char uChar;

char Monitoring(void)
{
	
	uChar promX, prumX=0;
	long k=0, peakX=0;
	wdt_reset();

	SPI_Init();  // inicializace SPI
	CSup();
	_delay_ms(200);


CSdown();
	SPI_Prenos(0b10101100); // vyslani adresovani na registr 16
	SPI_Prenos(0b00000101); // vyslani nastaveni registru 16
	CSup();
	
while(k<=(F_CPU/400))  // cyklus trva 66s
{
	wdt_reset(); // resetovani citace watchodogu

	// pro osu X
	CSdown();
	SPI_Prenos(0b00001100); // bude se cist z registru R6
	promX=SPI_Prenos(0); // data z registru R6
	CSup();
	
	if(promX>127)
	{
		promX=(256-promX)*2+promX;
	}
	
	prumX=(prumX+promX)/2;
	
	if((promX-prumX)>3) // nalezeni prahove hodnoty pro vyhodnocovani cinnosti pro zrychleni v ose X
	{
		peakX=0;
		DDRD= (1<<DDD2);
		PORTD|=(1<<PD2);
		_delay_ms(200);
		PORTD&=(0<<PD2); 
	} 
	
	k++;
	peakX++;
	
	if (peakX>(F_CPU/1600)) return 1;
	}
	
	return 0;
}

char TestKomunikace(void)
{
	
	
	uChar j, odpoved;
	uChar at[4]={'A','T','\r','\0'};

	wdt_reset();
	USART_Init(BAUD); // inicializace USARTu
	j=0;

	_delay_ms(200);
	
	while (at[j]!='\0')
	{
	
	USART_Vysilani(at[j]); // vyslani prikazu AT
	j++;
	}
	
	j=0;

	while (j<=10)
	{
	wdt_reset();	
	odpoved=(uChar)USART_Prijem();
	 	if (odpoved=='K')
		{

			DDRD= (1<<DDD2);
			PORTD|=(1<<PD2);
			wdt_disable();
			_delay_ms(2000);
			wdt_enable(WDTO_2S);
			PORTD&=(0<<PD2);
			return 0;
		
		}
		j++;

	}
// pokud neprijde ok, musi se rozblikat dioda
	j=0;
	while (j<=10)
		{
		wdt_reset();	
	 	DDRD= (1<<DDD2);
		_delay_ms(200);
		PORTD|=(1<<PD2);
		_delay_ms(200);
		PORTD&=(0<<PD2);
		j++;
		}

	return 1;
}

void ZapnutiMT(void)
{
	
	uChar i=0;
	uChar povoleni[14]={'A','T','+','C','M','E','C','=','2','\r','\0'};
	uChar lKlavesa[14]={'A','T','+','C','K','P','D','=','"','[','"','\r','\0'};
	
	wdt_reset();
	DDRC=(1<<DDC1); 
	PORTC|=(1<<PC1); // log. 1 (stisknuti a pridrzeni klavesy pro zapnuti)
	_delay_ms(1000);
	PORTC&=(0<<PC1); // log. 0 (pusteni klavesy pro zapnuti)
	wdt_reset();
	/* zapnuti a nastaveni USARTu */
	
	USART_Init(BAUD);	
	wdt_disable();
	_delay_ms(8000); // cekani na potvrzeni zapnuti	
	wdt_enable(WDTO_2S);
	while(povoleni[i]!='\0') // AT+CMEC=2 (povoleni softwaroveho ovladani)
	{
		USART_Vysilani(povoleni[i]);
		i++;
	}
	
	_delay_ms(200);
	i=0;
	while(lKlavesa[i]!='\0') // AT+CKPD="["  (leva klavesa)
	{
		wdt_reset();
		USART_Vysilani(lKlavesa[i]);
		i++;
	}
}
char SMSka(void)
{
	uChar i=0, odpoved;
	uChar sms[23]={'A','T','+','C','M','S','S','=','1',',','"','7','3','7','4','5','6','6','1','3','"','\r','\0'};
	
	wdt_reset();
	USART_Init(BAUD); // inicializace USARTu

	_delay_ms(200);

	while (sms[i]!='\0')
	{
	USART_Vysilani(sms[i]); // vyslani AT prikazu pro SMS
	i++;
	}

	i=0;
	while (i<50)
{
	wdt_reset();
	odpoved=(uChar)USART_Prijem(); // odpoved telefonu
	if (odpoved=='K')
	{
	DDRD=(1<<DDD2); 
	PORTD|=(1<<PD2);
	wdt_disable(); // vypnuti watchdogu
	_delay_ms(2000);
	wdt_enable(WDTO_2S);
	PORTD&=(0<<PD2);
	return 0;
	}
		i++;
}

	 wdt_disable();
	 _delay_ms(2000);
	 wdt_enable(WDTO_2S);
		i=0;
		while (i<=10)
		{
		wdt_reset();	
	 	DDRD= (1<<DDD2);
		_delay_ms(200);
		PORTD|=(1<<PD2);
		_delay_ms(200);
		PORTD&=(0<<PD2);
		i++;
		}
		return 1;

}
